#ifndef FILEMANAGER_H
#define FILEMANAGER_H

#include <string>
#include <vector>

std::vector<std::string> split_string(std::string text, const char splitter, bool twoPart=false);
std::string symbol_eraser(std::string text, const char symbol);
float stringToFloat(std::string input);
int stringToInt(std::string input);
std::string floatToString(float input);
std::string intToString(int input);
bool encoder(std::string path, int frameRate=25, int scale=1, bool removeBmp=false);

class FileManager
{
public:
    FileManager();
    std::vector<std::string> read(std::string path);
    std::vector<float> load(std::string path);
    bool write(std::string path, std::vector<std::string>);
    bool save(std::string path, std::vector<float>);
};

#endif // FILEMANAGER_H
