#ifndef GPU_H
#define GPU_H

#include "gpudata.h"
#include <vector>
#include <string>

#define MEMORY_EFFECTIVE_MULTIPLICATOR 0.95f
#define BYTES_PER_PIXEL 128

void cudaTest(GpuData, int);

void cudaGasCorrect(GpuGasCorrectData, int);// поправка для газа
void cudaGasRieman(GpuGasRiemanData, int);// расчет разрыва римана
void cudaViscBuilder(GpuGasViscData, int);// расчет вязкости
void cudaGasSolver(GpuGasSolverData, int);// расчет состояния газа на след шаге
void cudaDataCorrect(GpuDataCorrectData, int);// расчет поправки для параметров газа
void cudaDataSolver(GpuDataSolverData, int);// расчет состояний параметров в будущем
void cudaGravity(GpuGravityData, int);//расчет гравитационных взаимодействий
void cudaBodyGravity(GpuBodyGravityData data, int size);//расчет взаимодействия тел
void cudaFinalize(GpuFinalizeData, int);// финальные действия расчета
int cudaDtIteration(GpuDtData, int);// поиск нового dt
void cudaDtCopy(GpuDtData, int);// поиск нового dt
void cudaRender(GpuRenderData, int);
void cudaCopyStrings(GpuCopyStringData, int);
void cudaSetConstData(GpuGravityBody * data);
GpuInfo cudaGetGpuInfo(int);//получить данные о видеокарте
bool cudaSelectGpu(int);
float cudaGetMinDt(float *,float * ,int);
float * cudaAllocateMemory(int);
float * cudaAllocateHostMemory(int);
GpuGravityBody * cudaAllocateHostMemoryBody(int size);
bool cudaFreeHostMemory(float *);
bool cudaFreeHostMemory(GpuGravityBody * ptr);
bool cudaFreeMemory(float *);
bool cudaPutToGpu(float *,float *, int);
bool cudaGetFromGpu(float *, float *, int);
std::vector<std::string> cudaGetGpusInfo();

#endif // GPU_H
