#include "log.h"

#include <math.h>
#include <iostream>

#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

void logger(std::string message,int * ival, float * fval)
{
    std::cout<<message;
    if(ival) std::cout<<*ival;
    if(fval) std::cout<<*fval;
    std::cout<<std::endl;
}

testView::testView(Position size, int fullSize,float * gpuinput,int width,Position pos)
{
    std::vector<float> input;
    input.resize(fullSize);
    cudaGetFromGpu(&input[0],gpuinput,fullSize);
    strings.resize(size.y);
    columns.resize(size.x);
    for(int i=0;i<size.y;i++)
    {
        strings[i].resize(size.x);
    }
    for(int i=0;i<size.x;i++)
    {
        columns[i].resize(size.y);
    }
    for(int i=0;i<size.x;i++)
    {
        for(int j=0;j<size.y;j++)
        {
            int p=(j+pos.y)*width+i+pos.x;
            if(p<input.size())
            {
                strings[j][i]=input[p];
                columns[i][j]=input[p];
            }
        }
    }
}

Testtate::Testtate(Position size,Position shift,GpuData gpuData, int fullSize, int width)
{
    ro=testView(size,fullSize,gpuData.Ro0,width,shift);
    p=testView(size,fullSize,gpuData.P0,width,shift);
    vx=testView(size,fullSize,gpuData.Vx0,width,shift);
    vy=testView(size,fullSize,gpuData.Vy0,width,shift);
    vs=testView(size,fullSize,gpuData.Vs0,width,shift);
    sc=testView(size,fullSize,gpuData.Sc0,width,shift);
    cs=testView(size,fullSize,gpuData.Cs0,width,shift);
    r1=testView(size,fullSize,gpuData.R10,width,shift);
    g1=testView(size,fullSize,gpuData.G10,width,shift);
    b1=testView(size,fullSize,gpuData.B10,width,shift);
    r2=testView(size,fullSize,gpuData.R20,width,shift);
    g2=testView(size,fullSize,gpuData.G20,width,shift);
    b2=testView(size,fullSize,gpuData.B20,width,shift);
    r3=testView(size,fullSize,gpuData.R30,width,shift);
    g3=testView(size,fullSize,gpuData.G30,width,shift);
    b3=testView(size,fullSize,gpuData.B30,width,shift);
    cro=testView(size,fullSize,gpuData.Ro1,width,shift);
    cp=testView(size,fullSize,gpuData.P1,width,shift);
    cvx=testView(size,fullSize,gpuData.Vx1,width,shift);
    cvy=testView(size,fullSize,gpuData.Vy1,width,shift);
    cvs=testView(size,fullSize,gpuData.Vs1,width,shift);
    csc=testView(size,fullSize,gpuData.Sc1,width,shift);
    ccs=testView(size,fullSize,gpuData.Cs1,width,shift);
    cr1=testView(size,fullSize,gpuData.R11,width,shift);
    cg1=testView(size,fullSize,gpuData.G11,width,shift);
    cb1=testView(size,fullSize,gpuData.B11,width,shift);
    cr2=testView(size,fullSize,gpuData.R21,width,shift);
    cg2=testView(size,fullSize,gpuData.G21,width,shift);
    cb2=testView(size,fullSize,gpuData.B21,width,shift);
    cr3=testView(size,fullSize,gpuData.R31,width,shift);
    cg3=testView(size,fullSize,gpuData.G31,width,shift);
    cb3=testView(size,fullSize,gpuData.B31,width,shift);

    for(int i=0;i<size.x;i++)
    {
        for(int j=1;j<size.y-1;j++)
        {
            if(min(0.75/(sqrt(p.strings[j][i]*1.4/ro.strings[j][i])+sqrt(vx.strings[j][i]*vx.strings[j][i]+vy.strings[j][i]*vy.strings[j][i])),ro.strings[j][i]/(vs.strings[j][i]+1e-6))<0.01)
            {
                float cro=ro.strings[j][i];
                float cp=p.strings[j][i];
                float cvx=vx.strings[j][i];
                float cvy=vy.strings[j][i];
                float cvs=vs.strings[j][i];
                int aaa=0;
                aaa++;
            }
            if(ccs.strings[j][i]<0.1)
            {
                int aaa=0;
                aaa++;
            }
            if((fabs(vy.strings[j][i])>100||fabs(vx.strings[j][i])>100))
            {
                float fvx=vx.strings[j][i];
                float fvy=vy.strings[j][i];
                int aaa=0;
                aaa++;
            }
            if(r1.strings[j][i]+g1.strings[j][i]+b1.strings[j][i]<1)
            {
                int aaa=0;
                aaa++;
            }
            if(p.strings[j][i]<1e-1)
            {
                int aaa=0;
                aaa++;
            }
        }
    }
}

TestStory::TestStory(Position Size, Position Shift, int String, int Column, int Fullsize, int Width, bool economy)
{
    size=Size;
    width=Width;
    string=String;
    column=Column;
    shift=Shift;
    fullsize=Fullsize;
    eco=economy;
    dy=false;
}

void TestStory::a_first(GpuData * data)
{
    s1=Testtate(size, shift, *data, fullsize,width);

    a_ro=dy?s1.ro.columns[column]:s1.ro.strings[string];
    a_p=dy?s1.p.columns[column]:s1.p.strings[string];
    a_v=dy?s1.vy.columns[column]:s1.vx.strings[string];
    a_vp=dy?s1.vx.columns[column]:s1.vy.strings[string];

    r1=dy?s1.r1.columns[column]:s1.r1.strings[string];
    g1=dy?s1.g1.columns[column]:s1.g1.strings[string];
    b1=dy?s1.b1.columns[column]:s1.b1.strings[string];

    if(eco)
    {
        s1=Testtate();
    }
}

void TestStory::b_gasCorrect(GpuData * data)
{
     s2_g_c=Testtate(size, shift, *data, fullsize,width);

    b_cro=dy?s2_g_c.cro.columns[column]:s2_g_c.cro.strings[string];
    b_cp=dy?s2_g_c.cp.columns[column]:s2_g_c.cp.strings[string];
    b_cv=dy?s2_g_c.cvy.columns[column]:s2_g_c.cvx.strings[string];
    b_cvp=dy?s2_g_c.cvx.columns[column]:s2_g_c.cvy.strings[string];

    if(eco)
    {
        s2_g_c=Testtate();
    }
}

void TestStory::c_gasRieman(GpuData * data)
{
     s3_g_r=Testtate(size, shift, *data, fullsize,width);

    c_fro=dy?s3_g_r.cr3.columns[column]:s3_g_r.cr3.strings[string];
    c_fp=dy?s3_g_r.cg3.columns[column]:s3_g_r.cg3.strings[string];
    c_fv=dy?s3_g_r.cb3.columns[column]:s3_g_r.cb3.strings[string];

    if(eco)
    {
        s3_g_r=Testtate();
    }
}

void TestStory::e_gasSolve(GpuData * data)
{
     s5_g_s=Testtate(size, shift, *data, fullsize,width);

    fl=dy?s5_g_s.cp.columns[column]:s5_g_s.cp.strings[string];

    d_nro=dy?s5_g_s.ro.columns[column]:s5_g_s.ro.strings[string];
    d_np=dy?s5_g_s.p.columns[column]:s5_g_s.p.strings[string];
    d_nv=dy?s5_g_s.vy.columns[column]:s5_g_s.vx.strings[string];
    d_nvp=dy?s5_g_s.vx.columns[column]:s5_g_s.vy.strings[string];

    if(eco)
    {
        s5_g_s=Testtate();
    }
}

void TestStory::d_gasVisc(GpuData * data)
{
     s4_v_b=Testtate(size, shift, *data, fullsize,width);

     d_vnp=dy?s4_v_b.cr2.columns[column]:s4_v_b.cr2.strings[string];
     d_vnv=dy?s4_v_b.cg2.columns[column]:s4_v_b.cg2.strings[string];
     d_vnvp=dy?s4_v_b.cb2.columns[column]:s4_v_b.cb2.strings[string];

     if(eco)
     {
         s4_v_b=Testtate();
     }
}

void TestStory::f_dataCorrect(GpuData * data)
{
     s6_d_c=Testtate(size, shift, *data, fullsize,width);

    cr1=dy?s6_d_c.cr1.columns[column]:s6_d_c.cr1.strings[string];
    cg1=dy?s6_d_c.cg1.columns[column]:s6_d_c.cg1.strings[string];
    cb1=dy?s6_d_c.cb1.columns[column]:s6_d_c.cb1.strings[string];

    if(eco)
    {
        s6_d_c=Testtate();
    }
}

void TestStory::g_dataSolve(GpuData * data)
{
     s7_d_s=Testtate(size, shift, *data, fullsize,width);

    nr1=dy?s7_d_s.r1.columns[column]:s7_d_s.r1.strings[string];
    ng1=dy?s7_d_s.g1.columns[column]:s7_d_s.g1.strings[string];
    nb1=dy?s7_d_s.b1.columns[column]:s7_d_s.b1.strings[string];

    if(eco)
    {
        s7_d_s=Testtate();
    }
}

void TestStory::h_finalize(GpuData * data)
{
     s8_f=Testtate(size, shift, *data, fullsize,width);

     if(eco)
     {
         s8_f=Testtate();
     }
}
