#ifndef logger_H
#define logger_H

#include <string>
#include "gpu.h"

void logger(std::string message,int * ival=0, float * fval=0);

struct Position
{
    int x;
    int y;
    Position(int X=0, int Y=0):x(X),y(Y){}
    Position operator+(Position other){return Position(x+other.x,y+other.y);}
};

struct Point
{
    float x;
    float y;
    Point(float X=0.0f, float Y=0.0f):x(X),y(Y){}
};

struct testView
{
    std::vector<std::vector<float> > strings;
    std::vector<std::vector<float> > columns;
    testView(){}
    testView(Position size, int fullSize, float * gpuinput,int width,Position pos=Position(0,0));
};

struct Testtate
{
    testView ro;
    testView p;
    testView vx;
    testView vy;
    testView vs;
    testView sc;
    testView cs;
    testView r1;
    testView g1;
    testView b1;
    testView r2;
    testView g2;
    testView b2;
    testView r3;
    testView g3;
    testView b3;
    testView cro;
    testView cp;
    testView cvx;
    testView cvy;
    testView cvs;
    testView csc;
    testView ccs;
    testView cr1;
    testView cg1;
    testView cb1;
    testView cr2;
    testView cg2;
    testView cb2;
    testView cr3;
    testView cg3;
    testView cb3;
    Testtate(){}
    Testtate(Position size,Position shift,GpuData gpuData, int fullSize, int width);
};

struct TestStory
{
    Position size;
    int fullsize;
    int width;
    int string;
    int column;
    Position shift;
    float time;
    bool dy;
    bool eco;

    Testtate s1;
    Testtate s2_g_c;
    Testtate s3_g_r;
    Testtate s4_v_b;
    Testtate s5_g_s;
    Testtate s6_d_c;
    Testtate s7_d_s;
    Testtate s8_f;

    std::vector<float> a_ro;
    std::vector<float> a_p;
    std::vector<float> a_v;
    std::vector<float> a_vp;

    std::vector<float> b_cro;
    std::vector<float> b_cp;
    std::vector<float> b_cv;
    std::vector<float> b_cvp;

    std::vector<float> c_fro;
    std::vector<float> c_fp;
    std::vector<float> c_fv;

    std::vector<float> d_nro;
    std::vector<float> d_np;
    std::vector<float> d_nv;
    std::vector<float> d_nvp;
    std::vector<float> d_vnp;
    std::vector<float> d_vnv;
    std::vector<float> d_vnvp;

    std::vector<float> r1;
    std::vector<float> g1;
    std::vector<float> b1;

    std::vector<float> cr1;
    std::vector<float> cg1;
    std::vector<float> cb1;

    std::vector<float> nr1;
    std::vector<float> ng1;
    std::vector<float> nb1;

    std::vector<float> fl;

    TestStory(Position Size, Position Shift, int String, int Column, int Fullsize, int Width, bool economy=false);
    void a_first(GpuData * data);
    void b_gasCorrect(GpuData * data);
    void c_gasRieman(GpuData * data);
    void d_gasVisc(GpuData * data);
    void e_gasSolve(GpuData * data);
    void f_dataCorrect(GpuData * data);
    void g_dataSolve(GpuData * data);
    void h_finalize(GpuData * data);
};


#endif // logger_H
