#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

Graphics::TBitmap *Bitmap1;

int **TP;
float **Ro, **P, **Vx, **Vy;
float **Ron, **Pn, **Vxn, **Vyn;

float TF[256], TB[256], MD[256];
float TT[256];

int NumOfThreads;
int NumOfExec=0;
int NumOfWait;
float FPS;
int MinStep;
int MaxStep;
int MarkVis;
int MetalDestr;
int xsize, ysize;
int TipeDraw;
int ExEn;

float TimeMult;
float ViscMult;
float EnergMult;
float TempCond;
float G;
float AirTemp;
float FullTime;
float AllVx=0, AllVy=0;
float tau=0.000001;
float Vmax=1000000;
float ctime=0;
float EPSILON=0.001;



//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

float mhs(float a,float b){
  float c;
  c=a*b;
  if(c<=0) return 0.;
  return((c+c)/(a+b));
}

float sgn(float x){
  if(x<0.) return -1.;
  else return 1.;
}

//---------------------------------------------------------------------------

void correctG(float G,float Rol,float Pl,float Vxl,float Vyl,float Ro,float P,float Vx,float Vy,float Ror,float Pr,float Vxr,float Vyr,float *dUU){
  int k, i;
  float ro,p,u,c2,z,c,q,U[5],V[5],La[5];
  for(k=0;k<4;k++) {dUU[k]=0.0;}

    U[1]=Ro-Rol;
    V[1]=Ror-Ro;
    U[2]=P-Pl;
    V[2]=Pr-P;
    U[3]=Vx-Vxl;
    V[3]=Vxr-Vx;
    U[4]=Vy-Vyl;
    V[4]=Vyr-Vy;

  ro=Ro; p=P; u=Vx;
  if(ro<EPSILON) ro=EPSILON;
  if(p<EPSILON) p=EPSILON;
  c2=G*p/ro;
  c=sqrt(c2);
  p=0.5*U[2]/c2;
  q=0.5*U[3]*ro/c;
  z=U[1];
  U[1]=p-q; U[3]=p+q; U[2]=z-p-p;
  p=0.5*V[2]/c2;
  q=0.5*V[3]*ro/c;
  z=V[1];
  V[1]=p-q; V[3]=p+q; V[2]=z-p-p;
  for(k=1;k<=4;k++) { U[k]=mhs(U[k],V[k]); }
  La[1]=(u-c)*tau; La[2]=u*tau; La[3]=(u+c)*tau;
  La[4]=La[2];
  for(k=1;k<=4;k++) { U[k]=0.5*(sgn(La[k])-La[k])*U[k]; }
  dUU[3]=U[4];
  dUU[0]=U[1]+U[2]+U[3];
  dUU[1]=c2*(U[1]+U[3]);
  dUU[2]=c*(U[3]-U[1])/ro;
}

//---------------------------------------------------------------------------

void rasp0(float G,float *S1,float *S2,float *S,float *D)
{ float EX0,A,B,RC1,RC2,EX=1.;
  float R,P,U,T,C,R1,P1,U1,T1,C1,R2,P2,U2,T2,C2;
  float RA,PA,EA,SA,CA,F1,FP1,A1,CL,RL;
  float RB,PB,EB,SB,CB,F2,FP2,A2,CP,RP;
  float HP,X,Y,UU,UR,Pnull=0.002;
  float EPS=0.001;
  float G1,G2,G4,G5,G7,G8,G9;
  int L,I;
 G1=(G-1.)/2.;   G2=(G+1.)/2.;   G4=(G+1.)/(4.*G); G5=2./(G-1.);
 G7=2.*G/(G-1.); G8=1./G2;      G9=1./G7;

if(S2[2]>=S1[2])
      { L= 1; EX0= EX; }
else  { L=-1; EX0=-EX;
        for(I=1;I<=4;I++) { A=S1[I]; S1[I]=S2[I]; S2[I]=A; }
      }
/*------------------------------------*/
R1 = S1[1]; P1 = S1[2];
if(R1<EPSILON) R1=EPSILON;
if(P1<EPSILON) P1=EPSILON;
C1 = sqrt(G*P1/R1); S1[0]=C1;
U1 = S1[3]*EX0 ;  T1 = - S1[4]*EX0;
R2 = S2[1];  P2 = S2[2];
if(R2<EPSILON) R2=EPSILON;
if(P2<EPSILON) P2=EPSILON;
C2 = sqrt(G*P2/R2);  S2[0]=C2;
U2 = S2[3]*EX0 ;  T2 = - S2[4]*EX0;
/*-------------------------------------------------------*/
   X = P2-P1; Y = U1-U2; RC1 = R1*C1; RC2 = R2*C2;
   P = P1 + RC1*(X+RC2*Y)/(RC1+RC2);
   F1 = G4/P1; A1 = RC1*(1. + F1*(P-P1));
   F2 = G4/P2; A2 = RC2*(1. + F2*(P-P2));
   P = P1 + A1*(X+A2*Y)/(A1+A2);
 /*------------------------------------------*/
   A =X/(P1+P2); B =Y/(C1+C2);
   if( 0.04*(A*A*A*2. + B*B) <= EPS)
   { A = F1*(P-P1); A1 = RC1*(1. + A*(1.-0.5*A*(1.-A)));
     A = F2*(P-P2); A2 = RC2*(1. + A*(1.-0.5*A*(1.-A)));
     U  = (A1*U1+A2*U2-X)/(A1+A2); goto LAST;
   }
 /*------------------------------------------*/
   RA = G2*R1; RB = G2*R2;  EA = G*R1*P1; EB = G*R2*P2;
   if( Y >= 0.)
   { UU = X/sqrt(EA+X*RA);
     if( Y >= UU )
     { P = P1 + A1*(X+A2*Y)/(A1+A2);
       do{ PA = P-P1; A = 1./(EA+PA*RA); SA = sqrt(A);
           F1 = PA*SA; FP1 = 0.5*(SA+SA*A*EA);
           PB = P-P2; B = 1./(EB+PB*RB); SB = sqrt(B);
           F2 = PB*SB; FP2 = 0.5*(SB+SB*B*EB);
           HP = (Y-F1-F2)/(FP1+FP2); P = P+HP;
         } while( fabs(HP/P) > EPS );
       U  = U1-F1-FP1*HP;
       A1 = 1./SA + 0.5*RA*SA*HP;
       A2 = 1./SB + 0.5*RB*SB*HP;
       goto LAST;
     }
   }
   CA=G5*C1; CB=G5*C2;   UR=CB*(pow(P1/P2,G9)-1.);
   if( Y > UR )
   { P = P1 + A1*(X+A2*Y)/(A1+A2);
     do{ if( P < 0. ) P = -0.1*P;
         PA = P-P1; A = 1./(EA+PA*RA); SA = sqrt(A);
         F1 = PA*SA; FP1 = 0.5*(SA+SA*A*EA);
         F2 = CB*(pow(P/P2,G9)-1.); FP2 = G9*(F2+CB)/P;
         HP = (Y-F1-F2)/(FP1+FP2); P = P+HP;
       } while( fabs(HP/P) > EPS );
     U  = U1-F1-FP1*HP;
     A1 = 1./SA + 0.5*RA*SA*HP;
     goto LAST;
   }
   A=(Y+CA+CB)/(UR+CA+CB);
   if(A<0.){ P=Pnull;    U=U1-CA*(pow(Pnull/P1,1./G7)-1.); }
     else  { P=P1*pow(A,G7); U=U1-CA*(A-1.); }
 /*------------------------------------------------*/
LAST:  B=P*G; D[2]=U;
  if(P1>=P) { D[1]=U1-C1; CL=C1+G1*(U1-U); RL=B/(CL*CL); }
     else   { D[1]=U1-A1/R1; RL=A1/(U-D[1]); CL=sqrt(B/RL); }
  if(P<=P2) { D[3]=U2+C2; CP=C2-G1*(U2-U); RP=B/(CP*CP); }
     else   { D[3]=U2+A2/R2; RP=A2/(D[3]-U); CP=sqrt(B/RP); }

  if(0<=D[1]) { R=R1; P=P1; U=U1; T=T1;  goto SEND; }
  if(0>=D[3]) { R=R2; P=P2; U=U2; T=T2;  goto SEND; }
  if(0<D[2])
  { if(P1>P && 0<U-CL)
    { U=U1-G8*(D[1]); if(U<=0) U=0.01*C1;
      C=U; A=C/C1; P=P1*pow(A,G7); R=G*P/(C*C); T=T1;
    }
    else { R=RL; T=T1; }
  }
  else
  { if(P<P2 && 0>U+CP)
    { U=U2-G8*(D[3]); if(U>=0) U=-0.01*C2;
      C=-U; A=C/C2; P=P2*pow(A,G7); R=G*P/(C*C); T=T2;
    }
    else { R=RP; T=T2; }
  }
SEND:
  S[1]=R; S[2]=P; S[3]=U*EX0; S[4]=-T*EX0;
  if(L<0) { D[2]=-D[2]; A=-D[1]; D[1]=-D[3]; D[3]=A;
            for(I=1;I<=4;I++) { A=S1[I]; S1[I]=S2[I]; S2[I]=A; }
          }
if(fabs(S[3])<1.0e-20)S[3]=0.;
if(fabs(S[4])<1.0e-20)S[4]=0.;
}

//---------------------------------------------------------------------------

void Vis(int i, int j){

  float Mux, Muy, Lambda;
  float Vxu, Vxd, Vxr, Vxl, Vxul, Vxur, Vxdr, Vxdl, Vyu, Vyd, Vyr, Vyl, Vyul, Vyur, Vydr, Vydl, Tu, Td ,Tl ,Tr;
  if(i>0&&TP[i-1][j]==0) Vxu=Vx[i-1][j]; else Vxu=Vx[i][j]*(1-ViscMult);
  if(i<ysize-1&&TP[i+1][j]==0) Vxd=Vx[i+1][j]; else Vxd=Vx[i][j]*(1-ViscMult);
  if(j>0&&TP[i][j-1]==0) Vxl=Vx[i][j-1]; else Vxl=Vx[i][j]*(1-ViscMult);
  if(j<xsize-1&&TP[i][j+1]==0) Vxr=Vx[i][j+1]; else Vxr=Vx[i][j]*(1-ViscMult);
  if(i>0&&j>0&&TP[i-1][j-1]==0) Vxul=Vx[i-1][j-1]; else Vxul=Vx[i][j]*(1-ViscMult);
  if(i>0&&j<xsize-1&&TP[i-1][j+1]==0) Vxur=Vx[i-1][j+1]; else Vxur=Vx[i][j]*(1-ViscMult);
  if(j>0&&i<ysize-1&&TP[i+1][j-1]==0) Vxdl=Vx[i+1][j-1]; else Vxdl=Vx[i][j]*(1-ViscMult);
  if(j<xsize-1&&i<ysize-1&&TP[i+1][j+1]==0) Vxdr=Vx[i+1][j+1]; else Vxdr=Vx[i][j]*(1-ViscMult);

  if(i>0&&TP[i-1][j]==0) Vyu=Vy[i-1][j]; else Vyu=Vy[i][j]*(1-ViscMult);
  if(i<ysize-1&&TP[i+1][j]==0) Vyd=Vy[i+1][j]; else Vyd=Vy[i][j]*(1-ViscMult);
  if(j>0&&TP[i][j-1]==0) Vyl=Vy[i][j-1]; else Vyl=Vy[i][j]*(1-ViscMult);
  if(j<xsize-1&&TP[i][j+1]==0) Vyr=Vy[i][j+1]; else Vyr=Vy[i][j]*(1-ViscMult);
  if(i>0&&j>0&&TP[i-1][j-1]==0) Vyul=Vy[i-1][j-1]; else Vyul=Vy[i][j]*(1-ViscMult);
  if(i>0&&j<xsize-1&&TP[i-1][j+1]==0) Vyur=Vy[i-1][j+1]; else Vyur=Vy[i][j]*(1-ViscMult);
  if(j>0&&i<ysize-1&&TP[i+1][j-1]==0) Vydl=Vy[i+1][j-1]; else Vydl=Vy[i][j]*(1-ViscMult);
  if(j<xsize-1&&i<ysize-1&&TP[i+1][j+1]==0) Vydr=Vy[i+1][j+1]; else Vydr=Vy[i][j]*(1-ViscMult);

  if(i>0&&TP[i-1][j]==0) Tu=P[i-1][j]/(Ro[i-1][j]*EnergMult*(G-1.)); else Tu=P[i][j]/(Ro[i][j]*EnergMult*(G-1.));
  if(i<ysize-1&&TP[i+1][j]==0) Td=P[i+1][j]/(Ro[i+1][j]*EnergMult*(G-1.)); else Td=P[i][j]/(Ro[i][j]*EnergMult*(G-1.));
  if(j>0&&TP[i][j-1]==0) Tl=P[i][j-1]/(Ro[i][j-1]*EnergMult*(G-1.)); else Tl=P[i][j]/(Ro[i][j]*EnergMult*(G-1.));
  if((j<xsize-1&&Ro[i][j+1]*EnergMult*(G-1.)<=0)||Ro[i][j]*EnergMult*(G-1.)<=0){
   i=i;
  }
  
  if(j<xsize-1&&TP[i][j+1]==0) Tr=P[i][j+1]/(Ro[i][j+1]*EnergMult*(G-1.)); else Tr=P[i][j]/(Ro[i][j]*EnergMult*(G-1.));

  Mux=ViscMult*Ro[i][j]*fabs(Vx[i][j]*4-Vxu-Vxd-Vxl-Vxr)/8;
  Muy=ViscMult*Ro[i][j]*fabs(Vy[i][j]*4-Vyu-Vyd-Vyl-Vyr)/8;
  Lambda=ViscMult*sqrt((G-1.)*P[i][j]);

  Vxn[i][j]+=tau*(Mux*(Vxr+Vxl+Vxu+Vxd-4*Vx[i][j])/8+(Mux+Lambda)*((Vxr+Vxl-2*Vx[i][j])/4+((Vydr-Vydl)/2-(Vyur-Vyul)/2)/2));//
  Vyn[i][j]+=tau*(Muy*(Vyr+Vyl+Vyu+Vyd-4*Vy[i][j])/8+(Muy+Lambda)*((Vyu+Vyd-2*Vy[i][j])/4+((Vxdr-Vxdl)/2-(Vxur-Vxul)/2)/2));//
  Pn[i][j]+=

  tau*(
  Mux*(
    (Vxl-Vx[i][j])*(Vxl+Vx[i][j])/2-(Vx[i][j]-Vxr)*(Vxr+Vx[i][j])/2+
    (Vyu-Vy[i][j])*(Vyu+Vy[i][j])/2-(Vy[i][j]-Vyd)*(Vyd+Vy[i][j])/2+
    (Vxul-Vxdl)*(Vyl)/2-(Vxur-Vxdr)*(Vyr)/2)+
  Muy*(
    (Vyu-Vy[i][j])*(Vyu+Vy[i][j])/2-(Vy[i][j]-Vyd)*(Vyd+Vy[i][j])/2+
    (Vxu-Vx[i][j])*(Vxu+Vx[i][j])/2-(Vx[i][j]-Vxd)*(Vxd+Vx[i][j])/2+
    (Vyul-Vyur)*(Vxu)/2-(Vydl-Vydr)*(Vxd)/2
  )+
  Lambda*((Vxl-Vx[i][j])*(Vxl+Vx[i][j])/2-(Vx[i][j]-Vxr)*(Vxr+Vx[i][j])/2+(Vyul-Vydl)*(Vxl)/2-(Vyur-Vydr)*(Vxr)/2)+
  Lambda*((Vyu-Vy[i][j])*(Vyu+Vy[i][j])/2-(Vy[i][j]-Vyd)*(Vyd+Vy[i][j])/2+(Vxul-Vxur)*(Vyu)/2-(Vxdl-Vxdr)*(Vyd)/2))*(G-1.)+
  tau*TempCond*(G-1.)*(Tu+Td+Tl+Tr-4*P[i][j]/(Ro[i][j]*EnergMult*(G-1.)))/8;
}

//---------------------------------------------------------------------------

void Step1D(int st, int une, int beg, int end){

float Ua[5],Ub[5],Uc[5],Ud[5],Ul[5],DD[5],F[5];
float ro,p,u,e,v;
float Tr[8192],Tvx[8192],Tp[8192],Tvy[8192];
float Trn[8192],Tvxn[8192],Tpn[8192],Tvyn[8192];
float dUU[8192][4],dU[4], CV, PV;
int i,j,k,J=end-beg+2;

Ul[0]=Ul[1]=Ul[2]=Ul[3]=Ul[4]=-1;

if(st==1){
  for(i=beg;i<=end;i++){
    Tr[i-beg+1]=Ro[une][i];
    Tp[i-beg+1]=P[une][i];
    Tvx[i-beg+1]=Vx[une][i];
    Tvy[i-beg+1]=Vy[une][i];
  }
  CV=AllVx;
  PV=AllVy;
} else {
  for(i=beg;i<=end;i++){
    Tr[i-beg+1]=Ro[i][une];
    Tp[i-beg+1]=P[i][une];
    Tvx[i-beg+1]=Vy[i][une];
    Tvy[i-beg+1]=Vx[i][une];
  }
  CV=AllVy;
  PV=AllVx;
}

if(beg>0){
    Tr[0]=Tr[1];
    Tp[0]=Tp[1];
    Tvx[0]=-Tvx[1];
    if(MarkVis==1) Tvy[0]=Tvy[1]; else Tvy[0]=0;
  } else {

    Tr[0]=(1000+Tr[1])/2;
    Tp[0]=(Tp[1]+1000*AirTemp*EnergMult*(G-1.))/2;
    if(Tvx[1]>0) Tvx[0]=Tvx[1]*0.95; else Tvx[0]=Tvx[1];
    if(CV>0) Tvx[0]+=CV;
    Tvy[0]=PV+(Tvy[1]-PV)*0.95;
  }
  if(end+1!=st*xsize+(1-st)*ysize){
    Tr[J]=Tr[J-1];
    Tp[J]=Tp[J-1];
    Tvx[J]=-Tvx[J-1];
    if(MarkVis==1) Tvy[J]=Tvy[J-1]; else Tvy[J]=0;
  } else {

    Tr[J]=(1000+Tr[J-1])/2;
    Tp[J]=(Tp[J-1]+1000*AirTemp*EnergMult*(G-1.))/2;
    if(Tvx[J-1]<0) Tvx[J]=Tvx[J-1]*0.95; else Tvx[J]=Tvx[J-1];
    if(CV<0) Tvx[J]+=CV;
    Tvy[J]=PV+(Tvy[J-1]-PV)*0.95;
  }


for(i=1;i<J;i++) {
  correctG(1.4,Tr[i-1],Tp[i-1],Tvx[i-1],Tvy[i-1],Tr[i],Tp[i],Tvx[i],Tvy[i],Tr[i+1],Tp[i+1],Tvx[i+1],Tvy[i+1],dU);
  for(j=0;j<4;j++) dUU[i][j]=dU[j];
}

   for(k=0;k<4;k++)
   {
    dUU[0][k]=dUU[1][k];
    dUU[J][k]=dUU[J-1][k];
   }

   for(j=1;j<J;j++){

       if(Tr[j]+dUU[j][0]>0) Ub[1]=Tr[j]+dUU[j][0]; else Ub[1]=Tr[j];
       if(Tr[j+1]+dUU[j+1][0]>0) Uc[1]=Tr[j+1]+dUU[j+1][0]; else Uc[1]=Tr[j+1];

       if(Ub[1]<EPSILON) Ub[1]=EPSILON;
       if(Uc[1]<EPSILON) Uc[1]=EPSILON;

       if(Tp[j]+dUU[j][1]>0) Ub[2]=Tp[j]+dUU[j][1]; else Ub[2]=Tp[j];
       if(Tp[j+1]+dUU[j+1][1]>0) Uc[2]=Tp[j+1]+dUU[j+1][1]; else Uc[2]=Tp[j+1];

       if(Ub[2]<EPSILON) Ub[2]=EPSILON;
       if(Uc[2]<EPSILON) Uc[2]=EPSILON;


       Ub[3]=Tvx[j]+dUU[j][2];
       Uc[3]=Tvx[j+1]+dUU[j+1][2];

       Ub[4]=Tvy[j]+dUU[j][3];
       Uc[4]=Tvy[j+1]+dUU[j+1][3];

     if(Ul[0]<0&&Ul[1]<0&&Ul[2]<0&&Ul[3]<0&&Ul[4]<0){
       if(Tr[j-1]+dUU[j-1][0]>0) Ua[1]=Tr[j-1]+dUU[j-1][0]; else Ua[1]=Tr[j-1];
       if(Ua[1]<EPSILON) Ua[1]=EPSILON;
       if(Tp[j-1]+dUU[j-1][1]>0) Ua[2]=Tp[j-1]+dUU[j-1][1]; else Ua[2]=Tp[j-1];
       if(Ua[2]<EPSILON) Ua[2]=EPSILON;
       Ua[3]=Tvx[j-1]+dUU[j-1][2];
       Ua[4]=Tvy[j-1]+dUU[j-1][3];
       rasp0(G,Ua,Ub,Ud,DD);
       v=Ud[4]; ro=Ud[1]; u=Ud[3]; p=Ud[2]; e=p/(G-1)+0.5*ro*(u*u+v*v);
     }
     else
     {
     v=Ul[4]; ro=Ul[1]; u=Ul[3]; p=Ul[2]; e=Ul[0];
     }

     if(ro<EPSILON) {
       u=0;
       v=0;
       ro=EPSILON;
     }
     if(p<EPSILON*(G-1.)){
       p=EPSILON*(G-1.);
       e=EPSILON;
     }

     F[1]=ro*u;
     F[2]=ro*u*u+p;
     F[3]=ro*u*v;
     F[4]=(e+p)*u;
     rasp0(G,Ub,Uc,Ud,DD);
     v=Ud[4]; ro=Ud[1]; u=Ud[3]; p=Ud[2]; e=p/(G-1)+0.5*ro*(u*u+v*v);
     Ul[4]=v; Ul[1]=ro; Ul[3]=u; Ul[2]=p; Ul[0]=e;
     if(ro<EPSILON) {
       u=0;
       v=0;
       ro=EPSILON;
     }
     if(p<EPSILON*(G-1.)){
       p=EPSILON*(G-1.);
       e=EPSILON;
     }
     F[1]-=ro*u;
     F[2]-=ro*u*u+p;
     F[4]-=(e+p)*u;
     F[3]-=ro*u*v;
     Trn[j]=(tau)*F[1];
     Tvxn[j]=(tau)*F[2];
     Tvyn[j]=(tau)*F[3];
     Tpn[j]=(tau)*F[4];
    }

if(st==1){
  for(i=beg;i<=end;i++){
    Ron[une][i]+=Trn[i-beg+1];
    Pn[une][i]+=Tpn[i-beg+1];
    Vxn[une][i]+=Tvxn[i-beg+1];
    Vyn[une][i]+=Tvyn[i-beg+1];
    Vis(une,i);
  }
} else {
  for(i=beg;i<=end;i++){
    Ron[i][une]+=Trn[i-beg+1];
    Pn[i][une]+=Tpn[i-beg+1];
    Vyn[i][une]+=Tvxn[i-beg+1];
    Vxn[i][une]+=Tvyn[i-beg+1];
  }
}


}

//---------------------------------------------------------------------------

void threadY(int xf, int xe){
  int i,beg, end;
  for(i=xf;i<xe;i++){
    end=beg=0;
    while(end<ysize){
      while(beg<ysize&&TP[beg][i]!=0)
      {
        beg++;
      }
      end=beg;
      while(end<ysize&&TP[end][i]==0)
      {
        end++;
      }
      if(end-1<=beg) {
        beg++;
        end=beg;
        continue;
      }
      Step1D(0, i, beg, end-1);
      beg=end;
    }
  }
}

//---------------------------------------------------------------------------

void threadX(int yf, int ye){
  int i, beg, end;
  for(i=yf;i<ye;i++){
    end=beg=0;
    while(end<xsize){
      while(beg<xsize&&TP[i][beg]!=0){
        beg++;
      }
      end=beg;
      while(end<xsize&&TP[i][end]==0){
        end++;
      }
      if(end-1<=beg) {
        beg++;
        end=beg;
        continue;
      }
      Step1D(1, i, beg, end-1);
      beg=end;
    }
  }
}

//---------------------------------------------------------------------------

void multithreadX(){
  int WC=0;
  T1 *t1;
  T1 *t2;
  T1 *t3;
  T1 *t4;
  T1 *t5;
  T1 *t6;
  T1 *t7;
  T1 *t8;
  T1 *t9;
  T1 *t10;
  T1 *t11;
  T1 *t12;
  T1 *t13;
  T1 *t14;
  T1 *t15;
  T1 *t16;
  NumOfExec=0;
  if(NumOfThreads>=1) {t1=new T1(false,1,0,ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=2) {t2=new T1(false,1,ysize/NumOfThreads,2*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=3) {t3=new T1(false,1,2*ysize/NumOfThreads,3*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=4) {t4=new T1(false,1,3*ysize/NumOfThreads,4*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=5) {t5=new T1(false,1,4*ysize/NumOfThreads,5*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=6) {t6=new T1(false,1,5*ysize/NumOfThreads,6*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=7) {t7=new T1(false,1,6*ysize/NumOfThreads,7*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=8) {t8=new T1(false,1,7*ysize/NumOfThreads,8*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=9) {t9=new T1(false,1,8*ysize/NumOfThreads,9*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=10) {t10=new T1(false,1,9*ysize/NumOfThreads,10*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=11) {t11=new T1(false,1,10*ysize/NumOfThreads,11*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=12) {t12=new T1(false,1,11*ysize/NumOfThreads,12*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=13) {t13=new T1(false,1,12*ysize/NumOfThreads,13*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=14) {t14=new T1(false,1,13*ysize/NumOfThreads,14*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=15) {t15=new T1(false,1,14*ysize/NumOfThreads,15*ysize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=16) {t16=new T1(false,1,15*ysize/NumOfThreads,16*ysize/NumOfThreads); NumOfExec++; }
  while(NumOfExec>0){
    Sleep(NumOfWait);
    WC++;
    if(WC==10) {EPSILON=0.01;}
    if(WC==25) {EPSILON=0.1;}
    if(WC==50) {EPSILON=1;}
    if(WC>100) {break;}
  }
  if(WC==1) NumOfWait--; else NumOfWait+=(MinStep+MaxStep)/2;
  EPSILON=0.001;
  if(NumOfThreads>=1) t1->Free();
  if(NumOfThreads>=2) t2->Free();
  if(NumOfThreads>=3) t3->Free();
  if(NumOfThreads>=4) t4->Free();
  if(NumOfThreads>=5) t5->Free();
  if(NumOfThreads>=6) t6->Free();
  if(NumOfThreads>=7) t7->Free();
  if(NumOfThreads>=8) t8->Free();
  if(NumOfThreads>=9) t9->Free();
  if(NumOfThreads>=10) t10->Free();
  if(NumOfThreads>=11) t11->Free();
  if(NumOfThreads>=12) t12->Free();
  if(NumOfThreads>=13) t13->Free();
  if(NumOfThreads>=14) t14->Free();
  if(NumOfThreads>=15) t15->Free();
  if(NumOfThreads>=16) t16->Free();
}

//---------------------------------------------------------------------------

void multithreadY(){
  int WC=0;
  T1 *t1;
  T1 *t2;
  T1 *t3;
  T1 *t4;
  T1 *t5;
  T1 *t6;
  T1 *t7;
  T1 *t8;
  T1 *t9;
  T1 *t10;
  T1 *t11;
  T1 *t12;
  T1 *t13;
  T1 *t14;
  T1 *t15;
  T1 *t16;
  NumOfExec=0;
  if(NumOfThreads>=1) {t1=new T1(false,0,0,xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=2) {t2=new T1(false,0,xsize/NumOfThreads,2*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=3) {t3=new T1(false,0,2*xsize/NumOfThreads,3*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=4) {t4=new T1(false,0,3*xsize/NumOfThreads,4*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=5) {t5=new T1(false,0,4*xsize/NumOfThreads,5*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=6) {t6=new T1(false,0,5*xsize/NumOfThreads,6*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=7) {t7=new T1(false,0,6*xsize/NumOfThreads,7*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=8) {t8=new T1(false,0,7*xsize/NumOfThreads,8*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=9) {t9=new T1(false,0,8*xsize/NumOfThreads,9*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=10) {t10=new T1(false,0,9*xsize/NumOfThreads,10*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=11) {t11=new T1(false,0,10*xsize/NumOfThreads,11*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=12) {t12=new T1(false,0,11*xsize/NumOfThreads,12*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=13) {t13=new T1(false,0,12*xsize/NumOfThreads,13*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=14) {t14=new T1(false,0,13*xsize/NumOfThreads,14*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=15) {t15=new T1(false,0,14*xsize/NumOfThreads,15*xsize/NumOfThreads); NumOfExec++; }
  if(NumOfThreads>=16) {t16=new T1(false,0,15*xsize/NumOfThreads,16*xsize/NumOfThreads); NumOfExec++; }
  while(NumOfExec>0){
    Sleep(NumOfWait);
    WC++;
    if(WC==10) {EPSILON=0.01;}
    if(WC==25) {EPSILON=0.1;}
    if(WC==50) {EPSILON=1;}
    if(WC>100) {break;}
  }
  if(WC==1) NumOfWait--; else NumOfWait+=(MinStep+MaxStep)/2;
  EPSILON=0.001;
  if(NumOfThreads>=1) t1->Free();
  if(NumOfThreads>=2) t2->Free();
  if(NumOfThreads>=3) t3->Free();
  if(NumOfThreads>=4) t4->Free();
  if(NumOfThreads>=5) t5->Free();
  if(NumOfThreads>=6) t6->Free();
  if(NumOfThreads>=7) t7->Free();
  if(NumOfThreads>=8) t8->Free();
  if(NumOfThreads>=9) t9->Free();
  if(NumOfThreads>=10) t10->Free();
  if(NumOfThreads>=11) t11->Free();
  if(NumOfThreads>=12) t12->Free();
  if(NumOfThreads>=13) t13->Free();
  if(NumOfThreads>=14) t14->Free();
  if(NumOfThreads>=15) t15->Free();
  if(NumOfThreads>=16) t16->Free();
}

//---------------------------------------------------------------------------

void update(){
  int i,j;
  float ro, p ,vx,vy;
  Vmax=Vmax/2;
  for(i=0;i<ysize;i++){
  for(j=0;j<xsize;j++){
    if(TP[i][j]!=0) continue;
    ro=Ro[i][j];
    p=P[i][j];
    vx=Vx[i][j];
    vy=Vy[i][j];
    Ro[i][j]=Ro[i][j]+Ron[i][j];
    if(Ro[i][j]<EPSILON) {
      Vx[i][j]=0;
      Vy[i][j]=0;
      Ro[i][j]=EPSILON;
      P[i][j]=((p/(G-1)+0.5*ro*(vx*vx+vy*vy)+Pn[i][j])-0.5*Ro[i][j]*(Vx[i][j]*Vx[i][j]+Vy[i][j]*Vy[i][j]))*(G-1.);
      if(P[i][j]<EPSILON) P[i][j]=EPSILON;
    } else {
    Vx[i][j]=(Vx[i][j]*ro+Vxn[i][j])/Ro[i][j];
    Vy[i][j]=(Vy[i][j]*ro+Vyn[i][j])/Ro[i][j];
    P[i][j]=((p/(G-1)+0.5*ro*(vx*vx+vy*vy)+Pn[i][j])-0.5*Ro[i][j]*(Vx[i][j]*Vx[i][j]+Vy[i][j]*Vy[i][j]))*(G-1.);
    if(P[i][j]<EPSILON) P[i][j]=EPSILON;
    }

    Ron[i][j]=Pn[i][j]=Vxn[i][j]=Vyn[i][j]=0;
    if(Vmax<fabs(Vx[i][j])+fabs(Vy[i][j])+2*sqrt(P[i][j]/Ro[i][j]))
    {
      if(Ro[i][j]>1)
      {
      Vmax=fabs(Vx[i][j])+fabs(Vy[i][j])+2*sqrt(P[i][j]/Ro[i][j]);
      }
      else
      {
      Vmax=fabs(Vx[i][j])+fabs(Vy[i][j])+2*sqrt(P[i][j]*Ro[i][j]);
      }
    }
  }
  }
  tau=TimeMult/Vmax;
}

//---------------------------------------------------------------------------

void hardstep(){
  int i, j, k, nf=0;
  float t, d;
  for(i=0;i<ysize;i++){
    for(j=0;j<xsize;j++){
      if(TP[i][j]>0){

        if(TP[i][j]<1000){
          nf++;
          k=0;
          if(i>0) if(TP[i-1][j]==0) k++;
          if(i<ysize-1) if(TP[i+1][j]==0) k++;
          if(j>0) if(TP[i][j-1]==0) k++;
          if(j<xsize-1) if(TP[i][j+1]==0) k++;

          if(k==0) continue;

          if(i>0) if(TP[i-1][j]==0&&P[i][j]<P[i-1][j]/(Ro[i-1][j]*EnergMult*(G-1.))) P[i][j]=P[i-1][j]/(Ro[i-1][j]*EnergMult*(G-1.));
          if(i<ysize-1) if(TP[i+1][j]==0&&P[i][j]<P[i+1][j]/(Ro[i+1][j]*EnergMult*(G-1.))) P[i][j]=P[i+1][j]/(Ro[i+1][j]*EnergMult*(G-1.));
          if(j>0) if(TP[i][j-1]==0&&P[i][j]<P[i][j-1]/(Ro[i][j-1]*EnergMult*(G-1.))) P[i][j]=P[i][j-1]/(Ro[i][j-1]*EnergMult*(G-1.));
          if(j<xsize-1) if(TP[i][j+1]==0&&P[i][j]<P[i][j+1]/(Ro[i][j+1]*EnergMult*(G-1.))) P[i][j]=P[i][j+1]/(Ro[i][j+1]*EnergMult*(G-1.));

          if(P[i][j]<TB[TP[i][j]]) continue;

          if(tau*k*TT[TP[i][j]]<Ro[i][j]){

            if(i>0) if(TP[i-1][j]==0) {Ro[i-1][j]=Ro[i-1][j]+tau*TT[TP[i][j]]; if(P[i-1][j]<(Ro[i-1][j]-tau*TT[TP[i][j]])*TF[TP[i][j]]*EnergMult*(G-1.)) P[i-1][j]=Ro[i-1][j]*TF[TP[i][j]]*EnergMult*(G-1.); else P[i-1][j]=P[i-1][j]*Ro[i-1][j]/(Ro[i-1][j]-tau*TT[TP[i][j]]);}
            if(i<ysize-1) if(TP[i+1][j]==0) {Ro[i+1][j]=Ro[i+1][j]+tau*TT[TP[i][j]]; if(P[i+1][j]<(Ro[i+1][j]-tau*TT[TP[i][j]])*TF[TP[i][j]]*EnergMult*(G-1.)) P[i+1][j]=Ro[i+1][j]*TF[TP[i][j]]*EnergMult*(G-1.); else P[i+1][j]=P[i+1][j]*Ro[i+1][j]/(Ro[i+1][j]-tau*TT[TP[i][j]]);}
            if(j>0) if(TP[i][j-1]==0) {Ro[i][j-1]=Ro[i][j-1]+tau*TT[TP[i][j]]; if(P[i][j-1]<(Ro[i][j-1]-tau*TT[TP[i][j]])*TF[TP[i][j]]*EnergMult*(G-1.)) P[i][j-1]=Ro[i][j-1]*TF[TP[i][j]]*EnergMult*(G-1.); else P[i][j-1]=P[i][j-1]*Ro[i][j-1]/(Ro[i][j-1]-tau*TT[TP[i][j]]);}
            if(j<xsize-1) if(TP[i][j+1]==0) {Ro[i][j+1]=Ro[i][j+1]+tau*TT[TP[i][j]]; if(P[i][j+1]<(Ro[i][j+1]-tau*TT[TP[i][j]])*TF[TP[i][j]]*EnergMult*(G-1.)) P[i][j+1]=Ro[i][j+1]*TF[TP[i][j]]*EnergMult*(G-1.); else P[i][j+1]=P[i][j+1]*Ro[i][j+1]/(Ro[i][j+1]-tau*TT[TP[i][j]]);}

            Ro[i][j]-=tau*k*TT[TP[i][j]];
          } else {
            if(i>0) if(TP[i-1][j]>0) {P[i-1][j]=P[i][j];}
            if(i<ysize-1) if(TP[i+1][j]>0) {P[i+1][j]=P[i][j];}
            if(j>0) if(TP[i][j-1]>0) {P[i][j-1]=P[i][j];}
            if(j<xsize-1) if(TP[i][j+1]>0) {P[i][j+1]=P[i][j];}

            P[i][j]=Ro[i][j]*TF[TP[i][j]]*EnergMult*(G-1.);

            TP[i][j]=100000;
          }
        }
        if(TP[i][j]>1000&&TP[i][j]<2000){
          if(MetalDestr==0) continue;
          k=0;
          d=0;
          if(i>0) if(TP[i-1][j]==0) {k++; d+=tau*Vx[i-1][j]*(P[i-1][j]/(Ro[i-1][j]*EnergMult*(G-1.)))/MD[TP[i][j]-1000];}
          if(i<ysize-1) if(TP[i+1][j]==0) {k++; d+=tau*Vx[i+1][j]*(P[i+1][j]/(Ro[i+1][j]*EnergMult*(G-1.)))/MD[TP[i][j]-1000];}
          if(j>0) if(TP[i][j-1]==0) {k++; d+=tau*Vx[i][j-1]*(P[i][j-1]/(Ro[i][j-1]*EnergMult*(G-1.)))/MD[TP[i][j]-1000];}
          if(j<xsize-1) if(TP[i][j+1]==0) {k++; d+=tau*Vx[i][j+1]*(P[i][j+1]/(Ro[i][j+1]*EnergMult*(G-1.)))/MD[TP[i][j]-1000];}
          if(k==0) continue;
          if(d<Ro[i][j]){
            Ro[i][j]=Ro[i][j]-d;
          } else {
            TP[i][j]=100000;

              P[i][j]=Ro[i][j]*AirTemp*EnergMult*(G-1.);
            
          }
        }
      }
    }
  }
  for(i=0;i<ysize;i++){
      for(j=0;j<xsize;j++){
         if(TP[i][j]==100000) TP[i][j]=0;
      }
  }
  if(nf==0&&ExEn==1){
    for(i=0;i<ysize;i++){
      for(j=0;j<xsize;j++){
        if(TP[i][j]!=0){
          P[i][j]=AirTemp*1000*EnergMult*(G-1.);
          TP[i][j]=0;
        }
      }
    }
  }
}

//---------------------------------------------------------------------------

int ci=0;
float lst=0;

void drawit(int its){
  int i, j, r, g, b, aaa, ro;
  float T;


  ci++;
  if(ci>MaxStep||ctime-lst>=FPS){

    lst=ctime;
    if(ci<=MinStep) FPS=FPS*2;
    if(ci>=MaxStep) FPS=FPS/2;
    ci=0;


    ////////////////////////////////////////////////////////////////////////////
    if(TipeDraw==0){
      for(i=0;i<ysize;i++){
        for(j=0;j<xsize;j++){
          if(TP[i][j]==0){

          T=P[i][j]/(Ro[i][j]*EnergMult*(G-1.))-AirTemp;
          
          if(T<512) {
          r=g=b=255-(T/512)*256;
          }
          if(T>=512&&T<1024) {r=(T-512)/2; g=b=0;}
          if(T>=1024&&T<1536) {r=255;g=(T-1024)/2; b=0;}
          if(T>=1536&&T<5120) {r=255; g=255; b=(T-1536)/14;}
          if(T>=5120&&T<10240) {r=255-(T-5120)/40; g=255-(T-5120)/80; b=255;}
          if(T>=10240&&T<75776) {r=128-(T-10240)/512+random((T-10240)/256); g=192-(T-10240)/342+random((T-10240)/256); b=255;}
          if(T>=75776&&T<1048576) {r=random(256); g=random(256); b=255-(T-75776)/3800+random((T-75776)/3800);}
          if(T>=1048576) {r=random(256); b=random(256); g=255;}
          } else {
            if(TP[i][j]<1000){
              r=b=0;
              g=TP[i][j];
            } else {
              r=g=0;
              b=TP[i][j]-1000;
            }
          }
          if(r<0) r=0;
          if(g<0) g=0;
          if(b<0) b=0;
          if(r>255) r=255;
          if(g>255) g=255;
          if(b>255) b=255;
          aaa=r|(g<<8)|(b<<16);
          Bitmap1->Canvas->Pixels[j][i]=(TColor)aaa;
        }
      }
    }
    ////////////////////////////////////////////////////////////////////////////
    if(TipeDraw==1){

       for(i=0;i<ysize;i++){
        for(j=0;j<xsize;j++){
        if(TP[i][j]==0){
          r=g=b=255;
          if(Ro[i][j]<=1000) {ro=Ro[i][j]/100; if((ro/2)*2!=ro) r=g=b=255; else r=g=b=0; }
          if(Ro[i][j]>1000&&Ro[i][j]<=2000) {ro=Ro[i][j]/100; if((ro/2)*2!=ro) {r=g=0; b=255;} else r=g=b=255; }
          if(Ro[i][j]>2000&&Ro[i][j]<=10000) {ro=Ro[i][j]/1000; if((ro/2)*2!=ro) {r=b=0; g=255;} else r=g=b=255; }
          if(Ro[i][j]>10000&&Ro[i][j]<=100000) {ro=Ro[i][j]/10000; if((ro/2)*2!=ro) {g=b=0; r=255;} else r=g=b=255; }
          if(Ro[i][j]>100000) {ro=Ro[i][j]/100000; if((ro/2)*2!=ro) {g=random(256);b=random(256);r=random(256);} else r=g=b=255; }
         } else {
            if(TP[i][j]<1000){
              r=b=0;
              g=TP[i][j];
            } else {
              r=g=0;
              b=TP[i][j]-1000;
            }
          }
          if(r<0) r=0;
          if(g<0) g=0;
          if(b<0) b=0;
          if(r>255) r=255;
          if(g>255) g=255;
          if(b>255) b=255;
          aaa=r|(g<<8)|(b<<16);
          Bitmap1->Canvas->Pixels[j][i]=(TColor)aaa;
        }
      }
    }
    ////////////////////////////////////////////////////////////////////////////

    Bitmap1->SaveToFile(IntToStr(its)+"_"+FloatToStr(ctime)+".bmp");
  }
}

//---------------------------------------------------------------------------
void Begin(){
int i, j, rgb,  r, g, b, rof[256], rom[256], Zippo;

AirTemp=StrToFloat(Form1->Edit33->Text);
if(AirTemp<1) AirTemp=1;
if(AirTemp>1000000) AirTemp=1000000;
NumOfThreads=Form1->Threads->ItemIndex+1;
if(NumOfThreads<1) NumOfThreads=1;
if(NumOfThreads>16) NumOfThreads=16;
MinStep=StrToInt(Form1->Edit3->Text);
if(MinStep<1) MinStep=1;
if(MinStep>1000) MinStep=1000;
MaxStep=StrToInt(Form1->Edit4->Text);
if(MaxStep<=MinStep) MaxStep=MinStep+1;
if(MaxStep>1000000) MaxStep=1000000;
MarkVis=Form1->CheckBox1->Checked;
MetalDestr=Form1->CheckBox2->Checked;
TipeDraw=Form1->ComboBox4->ItemIndex;
if(TipeDraw<0) TipeDraw=0;
if(TipeDraw>1) TipeDraw=1;
Zippo=StrToInt(Form1->Edit32->Text)+AirTemp;
if(Zippo<1) Zippo=1;
if(Zippo>1000000) Zippo=1000000;
ExEn=Form1->CheckBox4->Checked;

TimeMult=0.75;
if(Form1->TauMu->ItemIndex==0) TimeMult=0.1;
if(Form1->TauMu->ItemIndex==1) TimeMult=0.2;
if(Form1->TauMu->ItemIndex==2) TimeMult=0.3;
if(Form1->TauMu->ItemIndex==3) TimeMult=0.4;
if(Form1->TauMu->ItemIndex==4) TimeMult=0.5;
if(Form1->TauMu->ItemIndex==5) TimeMult=0.6;
if(Form1->TauMu->ItemIndex==6) TimeMult=0.7;
if(Form1->TauMu->ItemIndex==7) TimeMult=0.75;
if(Form1->TauMu->ItemIndex==8) TimeMult=0.8;
if(Form1->TauMu->ItemIndex==9) TimeMult=0.85;
if(Form1->TauMu->ItemIndex==10) TimeMult=0.90;
if(Form1->TauMu->ItemIndex==11) TimeMult=0.95;
if(Form1->TauMu->ItemIndex==12) TimeMult=0.99;

ViscMult=0.5;
if(Form1->ComboBox1->ItemIndex==0) ViscMult=0;
if(Form1->ComboBox1->ItemIndex==1) ViscMult=0.1;
if(Form1->ComboBox1->ItemIndex==2) ViscMult=0.3;
if(Form1->ComboBox1->ItemIndex==3) ViscMult=0.5;
if(Form1->ComboBox1->ItemIndex==4) ViscMult=0.7;
if(Form1->ComboBox1->ItemIndex==5) ViscMult=0.9;
if(Form1->ComboBox1->ItemIndex==6) ViscMult=1;

EnergMult=StrToFloat(Form1->Edit1->Text);
if(EnergMult<1) EnergMult=1;
if(EnergMult>1000000) EnergMult=1000000;

TempCond=0;
if(Form1->ComboBox3->ItemIndex==0) TempCond=0;
if(Form1->ComboBox3->ItemIndex==1) TempCond=0.1;
if(Form1->ComboBox3->ItemIndex==2) TempCond=0.2;
if(Form1->ComboBox3->ItemIndex==3) TempCond=0.3;
if(Form1->ComboBox3->ItemIndex==4) TempCond=0.4;
if(Form1->ComboBox3->ItemIndex==5) TempCond=0.5;
if(Form1->ComboBox3->ItemIndex==6) TempCond=0.6;
if(Form1->ComboBox3->ItemIndex==7) TempCond=0.7;
if(Form1->ComboBox3->ItemIndex==8) TempCond=0.8;
if(Form1->ComboBox3->ItemIndex==9) TempCond=0.9;
if(Form1->ComboBox3->ItemIndex==10) TempCond=1;

G=1.4;
if(Form1->ComboBox2->ItemIndex==0) G=1.666666666;
if(Form1->ComboBox2->ItemIndex==0) G=1.4;
if(Form1->ComboBox2->ItemIndex==0) G=1.333333333;

FullTime=StrToFloat(Form1->Edit5->Text);
if(FullTime<1) FullTime=1;
if(FullTime>1000000) FullTime=1000000;
AllVx=StrToFloat(Form1->Edit34->Text);
if(AllVx<1) AllVx=1;
if(AllVx>1000000) AllVx=1000000;
AllVy=StrToFloat(Form1->Edit35->Text);
if(AllVy<1) AllVy=1;
if(AllVy>1000000) AllVy=1000000;

NumOfWait=sqrt(xsize*ysize)/NumOfThreads;

TP=new int*[ysize];
Ro=new float*[ysize];
P=new float*[ysize];
Vx=new float*[ysize];
Vy=new float*[ysize];
Ron=new float*[ysize];
Pn=new float*[ysize];
Vxn=new float*[ysize];
Vyn=new float*[ysize];

for(i=0;i<ysize;i++){
  TP[i]=new int[xsize];
  Ro[i]=new float[xsize];
  P[i]=new float[xsize];
  Vx[i]=new float[xsize];
  Vy[i]=new float[xsize];
  Ron[i]=new float[xsize];
  Pn[i]=new float[xsize];
  Vxn[i]=new float[xsize];
  Vyn[i]=new float[xsize];
}

for(i=0;i<ysize;i++){
for(j=0;j<xsize;j++){
  TP[i][j]=0;
  Ro[i][j]=0;
  P[i][j]=0;
  Vx[i][j]=0;
  Vy[i][j]=0;
  Ron[i][j]=0;
  Pn[i][j]=0;
  Vxn[i][j]=0;
  Vyn[i][j]=0;
}
}

rof[1]=1000*StrToInt(Form1->Edit6->Text);
TF[1]=StrToFloat(Form1->Edit7->Text)+AirTemp;
TT[1]=StrToFloat(Form1->Edit8->Text);
TB[1]=StrToFloat(Form1->Edit9->Text)+AirTemp;

if(rof[1]<1) rof[1]=1;
if(TF[1]<1) TF[1]=1;
if(TT[1]<1) TT[1]=1;
if(TB[1]<1) TB[1]=1;
if(rof[1]>10000000) rof[1]=10000000;
if(TF[1]>2000000) TF[1]=2000000;
if(TT[1]>1000000) TT[1]=1000000;
if(TB[1]>1500000) TB[1]=1500000;

rof[64]=1000*StrToInt(Form1->Edit10->Text);
TF[64]=StrToFloat(Form1->Edit11->Text)+AirTemp;
TT[64]=StrToFloat(Form1->Edit12->Text);
TB[64]=StrToFloat(Form1->Edit13->Text)+AirTemp;

if(rof[64]<1) rof[64]=1;
if(TF[64]<1) TF[64]=1;
if(TT[64]<1) TT[64]=1;
if(TB[64]<1) TB[64]=1;
if(rof[64]>10000000) rof[64]=10000000;
if(TF[64]>2000000) TF[64]=2000000;
if(TT[64]>1000000) TT[64]=1000000;
if(TB[64]>1500000) TB[64]=1500000;

rof[128]=1000*StrToInt(Form1->Edit14->Text);
TF[128]=StrToFloat(Form1->Edit15->Text)+AirTemp;
TT[128]=StrToFloat(Form1->Edit16->Text);
TB[128]=StrToFloat(Form1->Edit17->Text)+AirTemp;

if(rof[128]<1) rof[128]=1;
if(TF[128]<1) TF[128]=1;
if(TT[128]<1) TT[128]=1;
if(TB[128]<1) TB[128]=1;
if(rof[128]>10000000) rof[128]=10000000;
if(TF[128]>2000000) TF[128]=2000000;
if(TT[128]>1000000) TT[128]=1000000;
if(TB[128]>1500000) TB[128]=1500000;

rof[192]=1000*StrToInt(Form1->Edit18->Text);
TF[192]=StrToFloat(Form1->Edit19->Text)+AirTemp;
TT[192]=StrToFloat(Form1->Edit20->Text);
TB[192]=StrToFloat(Form1->Edit21->Text)+AirTemp;

if(rof[192]<1) rof[192]=1;
if(TF[192]<1) TF[192]=1;
if(TT[192]<1) TT[192]=1;
if(TB[192]<1) TB[192]=1;
if(rof[192]>10000000) rof[192]=10000000;
if(TF[192]>2000000) TF[192]=2000000;
if(TT[192]>1000000) TT[192]=1000000;
if(TB[192]>1500000) TB[192]=1500000;

rof[255]=1000*StrToInt(Form1->Edit22->Text);
TF[255]=StrToFloat(Form1->Edit23->Text)+AirTemp;
TT[255]=StrToFloat(Form1->Edit24->Text);
TB[255]=StrToFloat(Form1->Edit25->Text)+AirTemp;

if(rof[255]<1) rof[255]=1;
if(TF[255]<1) TF[255]=1;
if(TT[255]<1) TT[255]=1;
if(TB[255]<1) TB[255]=1;
if(rof[255]>10000000) rof[255]=10000000;
if(TF[255]>2000000) TF[255]=2000000;
if(TT[255]>1000000) TT[255]=1000000;
if(TB[255]>1500000) TB[255]=1500000;

rom[1]=10*StrToInt(Form1->Edit26->Text);
MD[1]=StrToFloat(Form1->Edit27->Text)+AirTemp;

if(rom[1]<1) rom[1]=1;
if(MD[1]<1) MD[1]=1;
if(rom[1]>1000000) rom[1]=1000000;
if(MD[1]>1000000) MD[1]=1000000;

rom[128]=10*StrToInt(Form1->Edit28->Text);
MD[128]=StrToFloat(Form1->Edit29->Text)+AirTemp;

if(rom[128]<1) rom[128]=1;
if(MD[128]<1) MD[128]=1;
if(rom[128]>1000000) rom[128]=1000000;
if(MD[128]>1000000) MD[128]=1000000;

rom[255]=10*StrToInt(Form1->Edit30->Text);
MD[255]=StrToFloat(Form1->Edit31->Text)+AirTemp;

if(rom[255]<1) rom[255]=1;
if(MD[255]<1) MD[255]=1;
if(rom[255]>1000000) rom[255]=1000000;
if(MD[255]>1000000) MD[255]=1000000;

for(i=2;i<64;i++){
  rof[i]=(rof[1]*(64-i)+rof[64]*(i-1))/63;
  TF[i]=(TF[1]*(64-i)+TF[64]*(i-1))/63;
  TT[i]=(TT[1]*(64-i)+TT[64]*(i-1))/63;
  TB[i]=(TB[1]*(64-i)+TB[64]*(i-1))/63;
}

for(i=65;i<128;i++){
  rof[i]=(rof[64]*(128-i)+rof[128]*(i-64))/64;
  TF[i]=(TF[64]*(128-i)+TF[128]*(i-64))/64;
  TT[i]=(TT[64]*(128-i)+TT[128]*(i-64))/64;
  TB[i]=(TB[64]*(128-i)+TB[128]*(i-64))/64;
}

for(i=129;i<192;i++){
  rof[i]=(rof[128]*(192-i)+rof[192]*(i-128))/64;
  TF[i]=(TF[128]*(192-i)+TF[192]*(i-128))/64;
  TT[i]=(TT[128]*(192-i)+TT[192]*(i-128))/64;
  TB[i]=(TB[128]*(192-i)+TB[192]*(i-128))/64;
}

for(i=193;i<255;i++){
  rof[i]=(rof[192]*(255-i)+rof[255]*(i-192))/63;
  TF[i]=(TF[192]*(255-i)+TF[255]*(i-192))/63;
  TT[i]=(TT[192]*(255-i)+TT[255]*(i-192))/63;
  TB[i]=(TB[192]*(255-i)+TB[255]*(i-192))/63;
}

for(i=2;i<128;i++){
  rom[i]=(rom[1]*(128-i)+rom[128]*(i-1))/127;
  MD[i]=(MD[1]*(128-i)+MD[128]*(i-1))/127;
}

for(i=129;i<255;i++){
  rom[i]=(rom[128]*(255-i)+rom[255]*(i-128))/127;
  MD[i]=(MD[128]*(255-i)+MD[255]*(i-128))/127;
}

for(i=1;i<256;i++){
  TT[i]=TT[i]*rof[i];
}

for(i=0;i<ysize;i++){
  for(j=0;j<xsize;j++){
     rgb=(int)Bitmap1->Canvas->Pixels[j][i];
     r=rgb&0xff;
     g=(rgb&0xff00)>>8;
     b=(rgb&0xff0000)>>16;
     if(r==g&&r==b){
       TP[i][j]=0;
       Ro[i][j]=1+(r+g+b)*1000/765;
       P[i][j]=Ro[i][j]*AirTemp*EnergMult*(G-1.);
       Vx[i][j]=0;
       Vy[i][j]=0;
     }
     if(r>g&&r>b){
       TP[i][j]=0;
       Ro[i][j]=1+(r+g+b)*1000/765;
       P[i][j]=Ro[i][j]*Zippo*EnergMult*(G-1.);
       Vx[i][j]=0;
       Vy[i][j]=0;
     }
     if(g>r&&g>b){
       TP[i][j]=g;
       Ro[i][j]=rof[g];
       P[i][j]=0;
       Vx[i][j]=0;
       Vy[i][j]=0;
     }
     if(b>g&&b>r){
       TP[i][j]=1000+b;
       Ro[i][j]=rom[b];
       P[i][j]=0;
       Vx[i][j]=0;
       Vy[i][j]=0;
     }
  }
}



}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button2Click(TObject *Sender)
{
int step=0, i, j, r,g,b,aaa;
long k, m, n;
if(Bitmap1==NULL) return;

Form1->ClientHeight=0;
Form1->ClientWidth=0;

Begin();
FPS=tau*32;
while(ctime<FullTime){

  ctime=ctime+tau;
  step++;

  hardstep();

  if(step==5){
  for(j=0;j<xsize;j++){

  }
  }

  multithreadX();

  multithreadY();

  update();

  drawit(step);
}

exit(0);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 OpenPictureDialog1->Execute();
 if(OpenPictureDialog1->FileName.Length()<1) return;
 Bitmap1 = new Graphics::TBitmap();
 Bitmap1->LoadFromFile(OpenPictureDialog1->FileName);
 ysize=Bitmap1->Height;
 xsize=Bitmap1->Width;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button3Click(TObject *Sender)
{
if(Form1->ClientWidth==510) Form1->ClientWidth=960; else Form1->ClientWidth=510;
}
//---------------------------------------------------------------------------

